//
//  MyView.m
//  Ex41
//
//  Created by 川上 博 on 10/04/22.
//  Copyright 2010 徳島大学. All rights reserved.
//

#import "MyView.h"

@implementation MyView

- (id)initWithFrame:(NSRect)frameRect
{
    self = [super initWithFrame:frameRect];
    if (self != nil) {
		xmin=-20.0; xmax=30.0; ymin=-30.0; ymax=20.0;
		x=0.0; y=1.0; dx=0.4; dy=0.5; rad=40; rad2=rad/2.0;
		
		[NSTimer scheduledTimerWithTimeInterval:0.01
										 target:self
									   selector:@selector(drawAnother:)
									   userInfo:nil
										repeats:YES];
		
    }
    return (self);
}

- (BOOL)acceptsFirstResponder
{
	return YES;
}

static float RF(void)
{
	return ((float) rand()/(float)RAND_MAX);
}

- (void)drawBall:(NSRect )rect
{
	double a, b, u, v;
	
	//rough collision criteria
	if(x1>xmax){dx=-dx;}
	if(x1<xmin){dx=-dx;}
	if(y1>ymax){dy=-dy;}
	if(y1<ymin){dy=-dy;}
	
	xfactor = rect.size.width/(xmax-xmin);
	yfactor = rect.size.height/(ymax-ymin);
	a=xfactor*(x-xmin);
	b=yfactor*(y-ymin);
	x1=x+dx; //Silly ball dynamics for x-axis
	y1=y+dy; //Silly ball dynamics for y-axis
	u=xfactor*(x1-xmin);
	v=yfactor*(y1-ymin);
	x=x1;
	y=y1;
	
	[[NSColor colorWithDeviceRed:RF() green:RF() blue:RF() alpha:1.0] set];
    oval = [NSBezierPath bezierPath];
	[oval moveToPoint:NSMakePoint(a,b)];
    [oval appendBezierPathWithOvalInRect:NSMakeRect(u-rad2, v-rad2, rad, rad)];
	[oval fill];
//	[oval stroke];
}

- (void)drawRect:(NSRect)rect
{
	[[NSColor whiteColor] set];
	NSRectFill(rect);
}

- (void)drawAnother:(id)timer
{
    NSRect visRect;
	
    [self lockFocus];
    visRect = [self visibleRect];
    [self drawBall:visRect];
    [self unlockFocus];
    [[self window] flushWindow];
}

- (void) mouseDown:(NSEvent *)theEvent
{
	NSPoint temp;
	NSPoint loc=[theEvent locationInWindow];
	
	loc.x -= [self frame].origin.x;
	loc.y -= [self frame].origin.y;	
	x=loc.x/xfactor + xmin;
	y=loc.y/yfactor + ymin;		
	temp=[self convertPoint:loc toView:nil];
    [[NSColor redColor] set];
	[[NSBezierPath bezierPathWithOvalInRect:NSMakeRect(temp.x-rad2, temp.y-rad2, rad, rad)] fill];
}

- (void)keyDown:(NSEvent *)theEvent
{
	switch([[theEvent characters] characterAtIndex:0]){
		case 'q':case 'Q':case '\033':
			exit(0);
			break;
		case 'e':
			[self setNeedsDisplay:YES];
			break;
		default:
			break;
	}
}

@end
